<?php

/*
 * checks what DEF variables are present in cdef and returns them as array
 */
function cdef_components($cdef_string) {
	preg_match_all('/([a-z]{1})/',$cdef_string,$match);
	/*
	$tmp_match:
	[0] => a
	[3] => b
	*/
	return array_unique($match[0]);
}

/*
 * converts hexadecimal color representation to it's decimal form
 * in style "255,0,128"
 */
function hex2dec($hex) {
    $res=explode("\n",trim(chunk_split($hex,2)));
    foreach ($res as $id => $hex) 
	$res[$id] = hexdec($hex);
    $res = implode(",",$res);
    return $res;
}

/*
 * clean titles from garbage (like %&$#) before passing to the java-applet 
 */
function clean($str) {
    //return preg_replace('/\W+/',' ',$str); //sometimes in titles apear "%" sign and java-applet is unable to handle it as string
    
    //rrdtool output encloses titles with ""
    $str = str_replace('\"','^^',$str);
    $str = str_replace('"','',$str);
    $str = str_replace('^^','"',$str);
    $str = str_replace(',',';',$str);
    return $str;
}

/*
 * checks string against non-aplhanumeric characters
 */
function check_string($sid) {
    if ( preg_match('/[^\w+]/i', $sid) )
	return false;
    else 
	return true;
}

/*
 * saves output to the file (for debugging purposes)
 */
function write_file($file,$path,$content,$type) {
    if ($handle = fopen($path."/".$file,$type)) {
	$stat = fwrite($handle,$content);
	fclose($handle);
	if ($stat) return true;
    }
    return false;
}

/*
 *fully encodes string in base64
 */
function encode_base64($string) {
    $string = base64_encode($string);
    $string = str_replace(array('+','/','='),array('-','_','.'),$string);
    return $string;
}

/*
 * fully decodes base64 string
 */
function decode_base64($string) {
    $string = str_replace(array('-','_','.'),array('+','/','='),$string);
    $string = base64_decode($string);
    return $string;
}

/* 
 * searches for substring in array key
 */
function assoc($arr2look,$key) {
    foreach ($arr2look as $string)
        if (stristr($string,$key)) return $string;
    return false;
}

/*
 * outputs an error and terminates further processing
 */
function err_to_browser($err) {
    echo "
    <HTML>
     <HEAD>
	<TITLE>ZOND ERROR</TITLE>
    </HEAD>
    <BODY bgcolor = #F9F9F9>
	<TABLE width=100% height=100%>
	    <TR><TD align=middle>
		<strong><font color=red>ERROR:$err</font></strong>
	    </TD></TR>
	</TABLE>
    </BODY>
    </HTML>
    ";
    
    die();
}

/*
 * scatters/assembles string blocks according to password
 *
 *
 * @string $string - string to be scattered
 * @string $pass - password
 * @integer $BLOCK - scatter density
 * @boolean $forward - direction (scatter:false, assemple:true)
 * @return string
 *
 * by johnrembo@netzond.com
 */

function scatter($string,$pass,$BLOCK,$forward=true) {

    if (empty($BLOCK) || $BLOCK<=0) return $string;
    $SIZE=strlen($string);
    $encrypted='';

    //exclude symbols at the end (less than block size)
    $tail_pos=$SIZE-($SIZE%$BLOCK);
    $tail = substr($string,$tail_pos);
    $string = substr($string,0,$tail_pos);

    //convert password to unique non repeating digits
    $pass=preg_replace('/[^0-9]/','',md5($pass));
    
    $pass = function_exists('str_split') ? array_unique(str_split($pass)) : array_unique(str_split4($pass));

    //split received string into apropriate size chunks
    $big_blocks=str_split($string,count($pass)*$BLOCK);

    foreach ($big_blocks as $bblock) {

        $small_blocks=str_split($bblock,$BLOCK);
        $pass_c = count($pass);
        $sb_c=count($small_blocks);

        if ($sb_c<2) { $encrypted=$string; break; }

        $hash_blocks=array();
        $pos=0;

        //adopt digitized password to block size (increment or decrement)
        foreach ($pass as $p) {
            if ( $pos > 9 || $pos>=$pass_c || !isset($small_blocks[$p]) ) continue; //kadangi skaidom blokais nuo 0 iki 9, tai ir replacinimui naudojam max 10 bloku(g.b. ir maziau jei hashas mazhiau duos)
            $hash_blocks[]=$p;
            $pos++;
        }

        //fill missing keys (which were skipped previously) and check if block map isn't the same as original
        $symetric=true;
        for ($i=0;$i<$sb_c;$i++) {
            if (!isset($hash_blocks[$i])) {
                for ($j=0;$j<$sb_c;$j++) {
                    if (!in_array($j,$hash_blocks)) {
                        $hash_blocks[$i]=$j;
                        break;
                    }
                }
            }
            if ($hash_blocks[$i]!=$i) $symetric=false;
        }

        //emulate digitized password if block map matches original
        if ($symetric)
            for ($h=0;$h<$sb_c;$h++)
                $hash_blocks[$h] = ($sb_c-$h);

        //scatter-back
        if (!$forward) {
            $hash_blocks=array_flip($hash_blocks);
            ksort($hash_blocks);
        }

        //scatter blocks according to scheme
        $new_small_blocks = array_combine( array_keys(array_flip($hash_blocks)), array_values($small_blocks) );
        ksort($new_small_blocks);

//	for debugging:
//      print_r($small_blocks);
//      print_r($hash_blocks);
//      print_r($new_small_blocks);
        $encrypted .= implode($new_small_blocks,' ');
    }
    return str_replace(' ','',$encrypted).$tail;
}

/* 
 * adopts hash_blocks size if necessary
 */
function adopt_hbs($str_length,$hbs) {
    global $hash_blck_size;
    
    if ($str_length==0 || $hbs==0) return $hash_blck_size[0];
    
    $h_b_s = array_flip($hash_blck_size);
    
    //swapping of two blocks is pointless. decrease hash_block_size.
    while ( floor($str_length/$hbs)<2 ) {
    	$this_hbs = $h_b_s[$hbs];
	if ($this_hbs>0) $hbs=$hash_blck_size[$this_hbs-1];
	else return $hbs;
    }
    return $hbs;
}

/*
 * usage currently suspended
 */
function check_ini_vars() {
    if (ini_get('register_argc_argv')!=1)
	err_to_browser('ZOND plugin requires "register_argc_argv=On" in php.ini');
}

/*
 *emulate str_split on php<5
 */
function str_split4($text, $split = 1)
{
    if (!is_string($text) || (!is_numeric($split) && $split < 1) ) return false;
    
    $len = strlen($text);
    $array = array();
    $i = 0;
    
    while ($i < $len) {
        $key = NULL;
        
	for ($j = 0; $j < $split; $j += 1) { 
            $key .= $text{$i};
            $i += 1;    
        }
        
        $array[] = $key;
    }
    
    return $array;
}

/*
 * some definitions here to avoid code doubling in scripts
 */
$zond_config_params = array (
                            'width',
                            'height',
			    'autosize',
			    'scaletype',
			    'charttype',
                            'refresh',
                            'font_name',
                            'font_size',
                            'axis_pos',
                            'axis_rot',
                            'indicator',
                            'values',
			    'legtype',
                            'contour',
                            'majhorz',
                            'majvert',
                            'minvert',
                            'minhorz',                
                            'step',                   
                            'trans',
			    'user',
			    'pass',
			    'hash',
			    'hashed',
			    'hash_blcksize',
			    'security'
            );

$fonts = array (
                "Arial",                              
                "Arial Rounded MT Bold",              
                "Bitstream Vera Sans Mono",           
                "Century Gothic",                     
                "Courier",                            
                "Courier New",                        
                "Lucida Sans",                        
                "MS Reference Sans Serif",
                "Tahoma"
                );

$hash_blck_size = array (
			2,
			3,
			5,
			10,
			20,
			30,
			50
			);

$php_bin_path = read_config_option("path_php_binary");

$PROTO = ( isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on' ) ? 'https://' : 'http://' ;

?>
